
unit Plugin;

interface

function fnParse(RawBuffer: PChar; var Position: LongWord; var BufLen: LongWord;
 MaxBufLen: LongWord) : Boolean; stdcall;
function fnStepIt : Boolean; stdcall;
function fnInfo(InfoBuffer: PChar) : Boolean; stdcall;

implementation

const
  // string[255]
  DllInfo = 'VMS VT-Terminal blanker Version 1.12';

var
  InhibitFlag : Boolean;
  TextFlag    : Boolean;
  CrFlag      : Boolean;
  LfFlag      : Boolean;

function fnParse(RawBuffer: PChar; var Position: LongWord; var BufLen: LongWord;
 MaxBufLen: LongWord) : Boolean;
  // function has result to write -> TRUE
  // function does not have a result available -> FALSE
  // RawBuffer[MaxBufLen] is not to be terminated with #0
  // therefore we use BufLen as an indication of buffer length.

begin
  fnParse := not(InhibitFlag);
  case ord(RawBuffer[Position]) of
      10 :  begin
              if (LfFlag) then
                fnParse := False
              else
                begin
                  LfFlag := True;
                  if (TextFlag) then
                    fnParse := True;
                  if (CrFlag) then
                    begin
                      InhibitFlag := False;
                      TextFlag := False;
                    end;
                end;
            end;
      13 :  begin
              if (CrFlag) then
                fnParse := False
              else
                begin
                  CrFlag := True;
                  if (TextFlag) then
                    fnParse := True;
                  if (LfFlag) then
                    begin
                      InhibitFlag := False;
                      TextFlag := False;
                    end;
                end;
            end;
      27 :  begin
              InhibitFlag := True;
              fnParse := False;
            end;
      32 :  begin
              InhibitFlag := False;
              TextFlag := True;
            end;
  else
    begin
      if (TextFlag) then
        begin
          CrFlag := False;
          LfFlag := False;
        end;
    end;
  end;
end;


function fnStepIt : Boolean;

begin
  // function is available -> TRUE
  // function not available -> FALSE
  fnStepIt := False;
end;


function fnInfo(InfoBuffer: PChar) : Boolean;
var
  I : Byte;

begin
  // function is available -> TRUE
  // function not available -> FALSE
  for I := 0 to (Length(DllInfo) - 1) do
    InfoBuffer[I] := DllInfo[I + 1];
  InfoBuffer[Length(DllInfo)] := #0;
  fnInfo := True;
end;


// Initialization
begin
  InhibitFlag := False;
  TextFlag := False;
  CrFlag := False;
  LfFlag := False;
end.

